#ifndef __RDMACMPROCESSOR__
#define __RDMACMPROCESSOR__

#include <rdma/rdma_cma.h>
#include <rdma/rdma_verbs.h>
#include <stdint.h>
#include <thread>
#include <iostream>

#include "Logger.hpp"
#include "RdmaEndpointGroup.hpp"

class RdmaCmProcessor
{

    struct rdma_event_channel *_eventChannel{NULL};
    std::thread *_cmEventThread{NULL};
    RdmaEndpointGroup *_endpointGroup{NULL};
    bool _stop{false};

public:
    RdmaCmProcessor(RdmaEndpointGroup *group);
    struct rdma_cm_id *createId();
    void processCmEvent();
    void start(bool newThread);
    void close();
};
#endif