#ifndef __RDMAREPCQPROCESSOR__
#define __RDMAREPCQPROCESSOR__

#include <rdma/rdma_cma.h>
#include <rdma/rdma_verbs.h>
#include <stdint.h>
#include <iostream>
#include <thread>
#include <unordered_map>

#include "Executor.hpp"
#include "Logger.hpp"

class RdmaRepCqProcessor
{
public:
	struct ibv_comp_channel *_compChannel{NULL};
	struct ibv_cq *_completionQueue{NULL};
	std::thread *_compQueueThread{NULL};
	bool _stop{false};
	Executor *_executor{NULL};

	RdmaRepCqProcessor(Executor *ex, ibv_context *verbs, int compQueueSize);
	struct ibv_cq *getCq();
	void start();
	void processCQEvents();
	void processRepEvent(struct ibv_wc *data);
	void close();
};

#endif
