#ifndef __RDMASERVERENDPOINT__
#define __RDMASERVERENDPOINT__

#include <rdma/rdma_cma.h>
#include <rdma/rdma_verbs.h>
#include <stdint.h>
#include <errno.h>
#include <iostream>
#include <rocksdb/db.h>

#include "RdmaEndpoint.hpp"
#include "CqEventData.hpp"
#include "Logger.hpp"


class RdmaReplicationEndpoint : public RdmaEndpoint
{

    rocksdb::DB *_db;
    std::atomic<uint64_t> _requestId{12};
    
public:
    RdmaReplicationEndpoint(struct rdma_cm_id *id, struct ibv_cq *completionQueue, int sendQueueSize,
                       int recvQueueSize, int sendMsgSize, int recvMsgSize,rocksdb::DB *_db);

    void processCqEvent(struct ibv_wc wc);
    void processSendCompletion(struct ibv_wc* data);
    void processRecvCompletion(struct ibv_wc* data);
    int sendMessage(const char *buffer, uint32_t size);
    void close();
};
#endif