#ifndef __RDMASALCQPROCESSOR__
#define __RDMASALCQPROCESSOR__

#include <rdma/rdma_cma.h>
#include <rdma/rdma_verbs.h>
#include <stdint.h>
#include <iostream>
#include <thread>
#include <unordered_map>

#include "Executor.hpp"
#include "Logger.hpp"

class RdmaSalCqProcessor
{
public:
    struct ibv_comp_channel *_compChannel{NULL};
    struct ibv_cq *_completionQueue{NULL};
    std::thread *_compQueueThread{NULL};
    bool _stop{false};
    Executor *_executor{NULL};

    RdmaSalCqProcessor(Executor *ex, ibv_context *verbs, int compQueueSize);
    struct ibv_cq *getCq();
    void start();
    void processCQEvents();
    void close();
};

#endif
