#ifndef __TaskThread__
#define __TaskThread__

#include <iostream>
#include <queue>

#include "Runnable.hpp"
#include "CqEventData.hpp"
#include "MessageFormats.hpp"
#include "Logger.hpp"
#include "RdmaEndpointGroup.hpp"
#include "ConcurrentQueue.hpp"
#include <pthread.h>
#include "Logger.hpp"


class TaskThread
{

private:
    ConcurrentQueue *_taskQueue;
    bool _stop{false};
    int _id;
    pthread_t thread;
    RdmaEndpointGroup *_group;

public:
    TaskThread(int id, int cpu, ConcurrentQueue *, RdmaEndpointGroup *group);
    TaskThread(int id, ConcurrentQueue *, RdmaEndpointGroup *group);
    void replicateSalRequest(char *salRequest,uint32_t size);
    static void *run(void *object);
    void stop();
    void processEvent(struct ibv_wc *data);
    ~TaskThread();
};

#endif