#include <string>
#include<iostream>
#include<fstream>
#include<map>


class Properties{
    private:
    std::map<std::string,std::string> _props;
     const std::string _WHITESPACE = " \n\r\t\f\v";
    std::string ltrim(const std::string& s)
    {
        size_t start = s.find_first_not_of(_WHITESPACE);
        return (start == std::string::npos) ? "" : s.substr(start);
    }
 
    std::string rtrim(const std::string& s)
    {
        size_t end = s.find_last_not_of(_WHITESPACE);
        return (end == std::string::npos) ? "" : s.substr(0, end + 1);
    }
 
    std::string trim(const std::string& s)
    {
        return rtrim(ltrim(s)); 
    }


	public:
       
	Properties(std::string filename){
		//std::cout<<"Reading Properties From file named prop.config ...........\n";
	
		std::ifstream file (filename);
		if(!file.is_open()){
			std::cout<<"Confiq file opening failed\n";
			exit(0);
		}
		std::string line;
        std::string key,value;
        int delimPos;
        while(getline(file,line)){
            delimPos=line.find('#');
            line=trim(line);
            if(!line.empty()){
                line=line.substr(0,delimPos);
                delimPos=line.find('=');
                _props.insert(make_pair(trim(line.substr(0,delimPos)),trim(line.substr(delimPos+1))));
            }
        }
	}
    std::string getValue(std::string key){
        auto it=_props.find(key);
        if(it==_props.end()){
            return "";
        }
        return it->second;
    }   
};

/*
int main(){
	Properties prop;
    std::cout<<prop.getValue("NO_OF_CLIENT");
   // std::cout<<DEPARTURE_EVENT;
	return 11;
}
*/