#include <iostream>
#include "RdmaServerEndpointGroup.hpp"
#include "Executor.hpp"

#include "rocksdb/db.h"
#include "Properties.cpp"
#include "rocksdb/slice.h"
#include "rocksdb/options.h"
#include "Logger.hpp"

int main()
{
    CPPLog::LOG_ALWAYS("Starting Server Main Thread");
    Properties prop("prop.config");
    int sendQS = stoi(prop.getValue("sendQS"));
    int recvQS = stoi(prop.getValue("recvQS"));
    int compQS = stoi(prop.getValue("compQS"));
    int sendMS = stoi(prop.getValue("sendMS"));
    int recvMS = stoi(prop.getValue("recvMS"));
    std::string dbpath = prop.getValue("DB_PATH");
    std::string serverIP = prop.getValue("SERVER_IP");
    std::string serverPort = prop.getValue("SERVER_PORT");
    int executorPoolSize = stoi(prop.getValue("EXECUTOR_POOL_SIZE"));
    int enableLogging = stoi(prop.getValue("ENABLE_LOGGING"));
    if(enableLogging == 0)
        CPPLog::Logger::getInstance()->updateLogLevel(CPPLog::DISABLE_LOG);

    RdmaServerEndpointGroup *group = new RdmaServerEndpointGroup(sendQS, recvQS, compQS,
                                                                 sendMS, recvMS, dbpath);
    Executor *ex = new Executor(executorPoolSize, group);
    group->setExecutor(ex);
    group->bind(serverIP.c_str(), serverPort.c_str(), 2);
    //std::cout<<"calling start cm\n";
    group->startCmProcessor(false);
    std::cout<<"Started Server\n";
    // Just to make main thread wait else program will exit
    while (1)
        ;
}