package hpdos_rdma_offloaded;

import java.util.ArrayList;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ExperimentStatistics {
    final static Logger logger = LoggerFactory.getLogger("ExperimentStatistics");
    public static void collectStatistics(long latency, String path){
        if (path.equals("localWriteTime")) {
            BenchmarkingProperties.localWriteTime = BenchmarkingProperties.localWriteTime + latency;
            BenchmarkingProperties.localWriteTimes.add(latency);
        } else if(path.equals("replicationTime")){
            BenchmarkingProperties.replicationTime = BenchmarkingProperties.replicationTime + latency;
            BenchmarkingProperties.replicationTimes.add(latency);
        }else if(path.equals("invalidationTime")){
            BenchmarkingProperties.invalidationTime = BenchmarkingProperties.invalidationTime + latency;
            BenchmarkingProperties.invalidationTimes.add(latency);
        }else if(path.equals("write")){
            BenchmarkingProperties.writes ++;
        }
        // BenchmarkingProperties.writes ++;
    }

    public static void printStatistics(){
        logger.debug("Average local write latency time: " + BenchmarkingProperties.localWriteTime / BenchmarkingProperties.writes);
        logger.debug("Average replication latency time: " + BenchmarkingProperties.replicationTime / BenchmarkingProperties.writes);
        logger.debug("Average invalidation latency time: " + BenchmarkingProperties.invalidationTime / BenchmarkingProperties.writes);
        logger.debug("Total writes: " + BenchmarkingProperties.writes);

        int lastTenPercentLocalWrites = BenchmarkingProperties.localWriteTimes.size() / 10;
        int lastTenPercentReplicationWrites = BenchmarkingProperties.replicationTimes.size() / 10;
        int lastTenPercentInvalidationWrites = BenchmarkingProperties.invalidationTimes.size() / 10;
        
        List<Long> lastTwentyLocalWrites = BenchmarkingProperties.localWriteTimes.subList(BenchmarkingProperties.localWriteTimes.size()-lastTenPercentLocalWrites, BenchmarkingProperties.localWriteTimes.size());
        List<Long> lastTwentyReplicationWrites = BenchmarkingProperties.replicationTimes.subList(BenchmarkingProperties.localWriteTimes.size()-lastTenPercentReplicationWrites, BenchmarkingProperties.replicationTimes.size());
        List<Long> lastTwentyInvalidationWrites = BenchmarkingProperties.invalidationTimes.subList(BenchmarkingProperties.localWriteTimes.size()-lastTenPercentInvalidationWrites, BenchmarkingProperties.invalidationTimes.size());
        
        long sumLastTenPercentLocalWrites = 0;
        long sumLastTenPercentReplicationWrites = 0;
        long sumLastTenPercentInvalidationWrites = 0;

        for (Long number : lastTwentyLocalWrites) {
            sumLastTenPercentLocalWrites = sumLastTenPercentLocalWrites + number;
        }

        for (Long number : lastTwentyReplicationWrites) {
            sumLastTenPercentReplicationWrites = sumLastTenPercentReplicationWrites + number;
        }

        for (Long number : lastTwentyInvalidationWrites) {
            sumLastTenPercentInvalidationWrites = sumLastTenPercentInvalidationWrites + number;
        }
        logger.debug("Last ten percent writes: " + lastTenPercentLocalWrites);
        logger.debug("Average for last ten percent local write latency time: " + sumLastTenPercentLocalWrites / lastTenPercentLocalWrites);
        logger.debug("Average for last ten percent replication latency time: " + sumLastTenPercentReplicationWrites / lastTenPercentReplicationWrites);
        logger.debug("Average for last ten percent invalidation latency time: " + sumLastTenPercentInvalidationWrites / lastTenPercentInvalidationWrites);

    }

}

class BenchmarkingProperties {
    static long localWriteTime = 0;
    static long replicationTime = 0;
    static long invalidationTime = 0;
    static long writes = 0;
    static ArrayList<Long> localWriteTimes = new ArrayList<>();
    static ArrayList<Long> replicationTimes = new ArrayList<>();
    static ArrayList<Long> invalidationTimes= new ArrayList<>();
}
