package hpdos_rdma_offloaded.handler;

import org.rocksdb.RocksDB;

import com.ibm.disni.util.DiSNILogger;

import org.rocksdb.Options;
import org.rocksdb.RocksDBException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import hpdos_rdma_offloaded.protocol.Request;


public class StorageHandler implements AutoCloseable{

    RocksDB rocksDB;
    Options rockDbOptions;
    
    final static Logger logger = LoggerFactory.getLogger("StorageHandler");
    public StorageHandler(String dbpath) throws RocksDBException
    {
        logger.warn("Creating RocksDB");
        this.rockDbOptions = new Options();
        rockDbOptions.setCreateIfMissing(true);
        this.rocksDB = RocksDB.open(rockDbOptions,dbpath);
        logger.warn("Created RocksDB");
    }
    public void close()
    {
        rocksDB.close();
        rockDbOptions.close();
        logger.warn("Closing RocksDB instance");
    }

    public void create(byte[] key,byte[] value) throws RocksDBException{
        rocksDB.put(key,value);
    }
    public void create(Request request) throws RocksDBException {
        rocksDB.put(request.getKey(),request.getValue());
    }
    public byte[] read(byte[] key)throws RocksDBException
    {
        return rocksDB.get(key);
    }
    public byte[] read(Request request)throws RocksDBException
    {
        return rocksDB.get(request.getKey());
    }
    public void update(byte[] key,byte[] value) throws RocksDBException
    {
        rocksDB.put(key,value);
    }
    public void update(Request request) throws RocksDBException
    {
        rocksDB.put(request.getKey(),request.getValue());
    }
    public void delete(byte[] key) throws RocksDBException
    {
        rocksDB.delete(key);
    }
    public void delete(Request request) throws RocksDBException
    {
        rocksDB.delete(request.getKey());
    }
}