package hpdos_rdma_offloaded.lib;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

public class Property {
    public String host;
    public String masterIp;
    public String dbPath;
    public int poolsize;
    public int recvQueue;
    public int sendQueue;
    public int clusterSize;
    public int wqSize = recvQueue;
    public boolean polling;
    public int maxinline = 0;
    public int port;
    public long[] clusterAffinities;
    public boolean isMaster;
    public int nFollowers;
    public String[] followersIP;

    public Property(String path) throws IOException
    {
        InputStream inputStream = new FileInputStream(path);
        Properties prop = new Properties();
        prop.load(inputStream);

        isMaster = Boolean.valueOf((String)prop.get("app.MASTER")); 
        host =  prop.getProperty("app.HOST");
        dbPath = prop.getProperty("app.db_path");
        poolsize = Integer.valueOf( prop.getProperty("app.cpu_affinity"));
        recvQueue = Integer.valueOf(prop.getProperty("app.rdma_receive_queue"));
        sendQueue = Integer.valueOf( prop.getProperty("app.rdma_send_queue"));
        clusterSize = Integer.valueOf(prop.getProperty("app.rdma_cluster_size"));
        wqSize = recvQueue;
        maxinline = Integer.valueOf(prop.getProperty("app.rdma_max_inline"));
        port = Integer.valueOf(prop.getProperty("app.rdma_server_port"));
        polling = Boolean.valueOf(prop.getProperty("app.rdma_polling"));
        masterIp = String.valueOf(prop.getProperty("app.MASTER_IP"));

        clusterAffinities = new long[poolsize];
        for (int i = 0; i < poolsize; i++)
        {
            long cpu = 1L << i;
            clusterAffinities[i] = cpu;
        }
        if(isMaster)
        {
            nFollowers = Integer.valueOf(prop.getProperty("app.NFOLLOWER"));
            followersIP = new String[nFollowers];
            for(int i = 1;i<=nFollowers;i++)
                followersIP[i-1] = prop.getProperty("app.FOLLOWER"+i);
        }
    }
}
