package hpdos_rdma_offloaded.protocol;

import java.io.IOException;
import java.nio.ByteBuffer;

import com.ibm.darpc.DaRPCMessage;

public class Request implements DaRPCMessage
{
    private static int SERIALIZED_SIZE = 260;
    public int requestType;
    public byte[] key;
    public byte[] value;


    @Override
    public int write(ByteBuffer buffer) throws IOException
    {
        buffer.putInt(requestType);
        if(key == null)
            buffer.put(key);
        //if operation type is get and delete then value is not required
        if(requestType == RequestType.PUT)
        {
            buffer.put(value);
            //size of key+value+operationType
            return 4+key.length+value.length;
        }
        //else return  size of Key+operationType
        return 4+key.length;
    }

    @Override
    public void update(ByteBuffer buffer) throws IOException
    {
        requestType = buffer.getInt();
        if(key == null || key.length != 128)
           this.key  = new byte[128];
        buffer.get(key);
        if(requestType == RequestType.PUT)
        {
            if(value == null || value.length != 128)
                this.value = new byte[128];
            buffer.get(value);    
        }
    }

    @Override
    public int size() {
        //This method gives max size of request
        return SERIALIZED_SIZE;
    }
    
    public byte[] getKey() {
        return key;
    }

    public void setKey(byte[] key) {
        this.key = key;
    }

    public byte[] getValue() {
        return value;
    }

    public void setValue(byte[] value) {
        this.value = value;
    }

    public int getRequestType() {
        return requestType;
    }

    public void setRequestType(int requestType) {
        this.requestType = requestType;
    }

}
